
`timescale  1 ps / 1 ps

module test_fir;

	reg clock;
	reg x_avail;							// new sample is available
	reg signed [17:0] x_real;		// x is the sample input
	reg signed [17:0] x_imag;
	wire y_avail;						// new output is available
	wire signed [23:0] y_real;	// y is the filtered output
	wire signed [23:0] y_imag;
	reg coefReset;
	reg coefWR;
	reg [35:0] coef; 

	reg clkCnt;
	reg [15:0] cnt;


firX8R8 dut ( clock, x_avail, x_real, x_imag, y_avail, y_real, y_imag, coefReset, coefWR, coef);

initial
begin
	clock = 0;
	x_avail = 0;
	x_real = 0;
	x_imag = 0;

	coefReset = 0;
	coefWR = 0;
	coef = 0;

	clkCnt = 0;
	cnt = 0;
end


always
begin
	#2034 clock = !clock;
end


always @(posedge (clock))
  begin
	  clkCnt <= ~clkCnt;

	  if (clkCnt)
	  begin
		  cnt <= cnt+1;
		  if (cnt == 1)
			  coefReset <= 1;
		  else 
			  coefReset <= 0;
		  if (cnt>3 && cnt<1300) 
		  begin
			  if (cnt[0])
			  begin
				  coef <= cnt;
				  coefWR <= 1;
			  end
			  else
				  coefWR <= 0;
			  begin
			  end
		  end
		  if (cnt[10:0] == 0)
				  x_avail <= 1;
		  else
				  x_avail <= 0;


	  end
	  
  end


endmodule
